
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ui_announcementsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ui_announcements = await db.ui_announcements.create(
            {
                id: data.id || undefined,
        
        headline: data.headline
        ||
        null
            ,
            
        content: data.content
        ||
        null
            ,
            
        audience: data.audience
        ||
        null
            ,
            
        publish_from: data.publish_from
        ||
        null
            ,
            
        publish_to: data.publish_to
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await ui_announcements.setCompany( data.company || null, {
            transaction,
        });
        
        await ui_announcements.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return ui_announcements;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ui_announcementsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                headline: item.headline
            ||
            null
            ,
            
                content: item.content
            ||
            null
            ,
            
                audience: item.audience
            ||
            null
            ,
            
                publish_from: item.publish_from
            ||
            null
            ,
            
                publish_to: item.publish_to
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const ui_announcements = await db.ui_announcements.bulkCreate(ui_announcementsData, { transaction });

        // For each item created, replace relation files
        

        return ui_announcements;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const ui_announcements = await db.ui_announcements.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.headline !== undefined) updatePayload.headline = data.headline;
        
        
        if (data.content !== undefined) updatePayload.content = data.content;
        
        
        if (data.audience !== undefined) updatePayload.audience = data.audience;
        
        
        if (data.publish_from !== undefined) updatePayload.publish_from = data.publish_from;
        
        
        if (data.publish_to !== undefined) updatePayload.publish_to = data.publish_to;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await ui_announcements.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await ui_announcements.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await ui_announcements.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return ui_announcements;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ui_announcements = await db.ui_announcements.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of ui_announcements) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of ui_announcements) {
                await record.destroy({transaction});
            }
        });


        return ui_announcements;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const ui_announcements = await db.ui_announcements.findByPk(id, options);

        await ui_announcements.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await ui_announcements.destroy({
            transaction
        });

        return ui_announcements;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const ui_announcements = await db.ui_announcements.findOne(
            { where },
            { transaction },
        );

        if (!ui_announcements) {
            return ui_announcements;
        }

        const output = ui_announcements.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.company = await ui_announcements.getCompany({
            transaction
        });
        
        
        output.organizations = await ui_announcements.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
        where: filter.company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.company.split('|').map(term => Utils.uuid(term)) } },
            {
              company_name: {
                [Op.or]: filter.company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.headline) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ui_announcements',
                        'headline',
                        filter.headline,
                    ),
                };
            }
            
            if (filter.content) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ui_announcements',
                        'content',
                        filter.content,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            publish_from: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    publish_to: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.publish_fromRange) {
                const [start, end] = filter.publish_fromRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    publish_from: {
                    ...where.publish_from,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    publish_from: {
                    ...where.publish_from,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.publish_toRange) {
                const [start, end] = filter.publish_toRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    publish_to: {
                    ...where.publish_to,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    publish_to: {
                    ...where.publish_to,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.audience) {
                where = {
                    ...where,
                audience: filter.audience,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.ui_announcements.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'ui_announcements',
                        'headline',
                        query,
                    ),
                ],
            };
        }

        const records = await db.ui_announcements.findAll({
            attributes: [ 'id', 'headline' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['headline', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.headline,
        }));
    }

    
};

